<template>
  <div class="inventory">
    <h3>Welcome to your inventory page</h3>
    <!-- A container for all buttons above the inventory table -->
    <div class="options">
      <button type="button" class="btn btn-dark" data-toggle="modal" data-target="#createItemModal">New item</button>&nbsp;
      <button type="button" class="btn btn-dark" @click="changeSortValue()">Sort by: {{ sortDisplay }}</button>&nbsp;
      <button type="button" class="btn btn-dark" v-if="sortValue != null" @click="changeSortType()">
        <!-- This is the code for the ascending sort icon. The icon is bound to a condition.-->
        <svg v-if="sortType == true" xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-sort-alpha-up" viewBox="0 0 16 16">
          <path fill-rule="evenodd" d="M10.082 5.629 9.664 7H8.598l1.789-5.332h1.234L13.402 7h-1.12l-.419-1.371h-1.781zm1.57-.785L11 2.687h-.047l-.652 2.157h1.351z"/>
          <path d="M12.96 14H9.028v-.691l2.579-3.72v-.054H9.098v-.867h3.785v.691l-2.567 3.72v.054h2.645V14zm-8.46-.5a.5.5 0 0 1-1 0V3.707L2.354 4.854a.5.5 0 1 1-.708-.708l2-1.999.007-.007a.498.498 0 0 1 .7.006l2 2a.5.5 0 1 1-.707.708L4.5 3.707V13.5z"/>
        </svg>
        <!-- Here ends the code for the ascending icon and starts the code for the descending icon. The icon display is bound to a condition. -->
        <svg v-if="sortType == false" xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-sort-alpha-down" viewBox="0 0 16 16">
          <path fill-rule="evenodd" d="M10.082 5.629 9.664 7H8.598l1.789-5.332h1.234L13.402 7h-1.12l-.419-1.371h-1.781zm1.57-.785L11 2.687h-.047l-.652 2.157h1.351z"/>
          <path d="M12.96 14H9.028v-.691l2.579-3.72v-.054H9.098v-.867h3.785v.691l-2.567 3.72v.054h2.645V14zM4.5 2.5a.5.5 0 0 0-1 0v9.793l-1.146-1.147a.5.5 0 0 0-.708.708l2 1.999.007.007a.497.497 0 0 0 .7-.006l2-2a.5.5 0 0 0-.707-.708L4.5 12.293V2.5z"/>
        </svg>
      </button>
    </div>
    <!-- End of title area -->
    <!-- Modal to create item -->
      <div class="modal fade" id="createItemModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalCenterTitle" aria-hidden="true">
        <div class="modal-dialog modal-dialog-centered" role="document">
          <div class="modal-content">
            <div class="modal-header bg-dark">
              <h4 class="modal-title" id="exampleModalLongTitle" style="color: white;">New item: </h4>
              <button type="button" class="close" data-dismiss="modal" aria-label="Close" style="color:white;">
                <span aria-hidden="true">&times;</span>
              </button>
            </div>
            <div class="modal-body bg-dark">
              <!-- Create item for found inside a modal -->
              <form class="auth-inner bg-secondary" id="itemData" @submit="handleAdd">
                <div class="form-group">
                    <label>ID: </label>
                    <input type="text" class="form-control" v-model="slug" placeholder="An ID for your new item." :required="true" />
                </div>
                <div class="form-group">
                    <label>Item name: </label>
                    <input type="text" class="form-control" v-model="itemName" placeholder="A name for your item." :required="true"/>
                </div>
                <div class="form-group">
                    <label>Item description: </label>
                    <input type="text" class="form-control" v-model="body" placeholder="A description for your item." :required="true"/>
                </div>
                <div class="form-group">
                    <label>Item stock: </label>
                    <input type="Number" class="form-control" v-model="stockLevel" placeholder="How much items do you have in stock?" :required="true"/>
                </div>
                <div class="form-group">
                    <label>Category: </label>
                    <input type="text" class="form-control" v-model="category" placeholder="e.g. 'Small parts', 'Miscellaneous', 'Fruits'" :required="true"/>
                </div>
                <div class="form-group" v-if="inventory.customColumnOne != null">
                    <label>{{inventory.customColumnOne}}: </label>
                    <input type="text" class="form-control" v-model="customColumnOneData" placeholder="Data for your first custom column."/>
                </div>
                <div class="form-group" v-if="inventory.customColumnTwo != null">
                    <label>{{inventory.customColumnTwo}}: </label>
                    <input type="text" class="form-control" v-model="customColumnTwoData" placeholder="Data for your second custom column."/>
                </div>
              </form>
            </div>
            <div class="modal-footer bg-dark">
              <button type="button" class="btn btn-secondary" data-dismiss="modal">Cancel</button>
              <button type="submit" class="btn btn-primary" form="itemData">Create</button>
            </div>
          </div>
        </div>
      </div>
    <!-- End of item creation modal -->
    <!-- Start of the inventory table area -->
    <div class="table-margins">
      <!-- Inventory component is initialized here. -->
      <inv :inventory="inventory"
      :sortValue="sortValue"
      :sortType="sortType"
      @delete-item="deleteItem"
      @selected-item="sendItem"/>
    </div>
  </div>
</template>

<script>
// Calling the inventory component into this view
// Importing axios to make requests to the backend.
import axios from 'axios'
import $ from 'jquery'
import inv from '@/components/Inventory.vue'
export default {
  name: 'Inventory',
  props: ['inventory'],
  components: {
    inv
  },
  data () {
    return {
      baseUrl: 'http://localhost:8000/api/',
      slug: '',
      itemName: '',
      body: '',
      stockLevel: Number,
      category: '',
      customColumnOneData: '',
      customColumnTwoData: '',
      sortValue: null,
      sortType: null
    }
  },
  computed: {
    // sorting method to show the items ordered depending of sortValue status
    sortDisplay: function () {
      if (this.sortValue === true) {
        return 'ID'
      } else if (this.sortValue === false) {
        return 'Item'
      } else {
        return ''
      }
    }
  },
  methods: {
    // method to request an item creation to the backend
    async handleAdd () {
      console.log(this.inventory.inventory_id)
      await axios.post(this.baseUrl + 'items', {
        inventory_id: this.inventory.inventory_id,
        slug: this.slug,
        itemName: this.itemName,
        body: this.body,
        stockLevel: this.stockLevel,
        category: this.category,
        customColumnOneData: this.customColumnOneData,
        customColumnTwoData: this.customColumnTwoData
      })
      $('#createItemModal').modal('hide')
      this.$router.go(-1)
    },
    // method to delete an item
    deleteItem (id) {
      axios.delete(this.baseUrl + 'items', {
        params: {
          item_id: id
        }
      })
      this.$router.push('/')
    },
    sendItem (e, y) {
      this.$emit('selected-item', e, y)
    },
    // sort button toggle
    changeSortValue () {
      this.sortType = true
      if (this.sortValue === true) {
        this.sortValue = false
      } else {
        this.sortValue = true
      }
    },
    // ascending/descending sorting toggle
    changeSortType () {
      if (this.sortType === true) {
        this.sortType = false
      } else {
        this.sortType = true
      }
    }
  }
}
</script>

<style scoped="scss">
/* Temporary css to make the page more appealing to the eye */
  .options {
    text-align: left;
    margin-left: 3%;
  }
  .inventory {
    color: whitesmoke;
  }
  .table-margins {
      margin-left: 20px;
      margin-right: 20px;
  }
  .modal-header {
    border-bottom: 0 none;
    padding-bottom: 0;
  }

  .modal-footer {
    border-top: 0 none;
    padding-top: 0;
  }
</style>
